VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "NoKeyTransmission"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Modul As Long             ' ffentliches Modul fr die Exponentialfunktion
Public A As Party, B As Party    ' Unsere involvierten Parteien

' Anwerfen
Public Sub Initialize(ByVal Party1 As Party, ByVal Party2 As Party, _
    Optional ByVal MinModule As Long = 2000)
   Set A = Party1
   Set B = Party2

   Modul = NextPrime(MinModule)
   
   ' Parteien intialisieren
   Call A.Initialize(Me)
   Call B.Initialize(Me)
End Sub

Public Sub Arrange(Value As Long)
   ' Klartext
   Dim k As Long
   ' Die Zwischenstufen - berflssig aber vom Verstndnis hilfreich
   Dim c1 As Long, c2 As Long, c3 As Long
   
   k = Value
   
   c1 = A.Encrypt(k)    ' Von A verschlsselt
   Call Form1.List3.AddItem("c1 = " & CStr(c1))
   
   c2 = B.Encrypt(c1)   ' Von A und B verschlsselt
   Call Form1.List3.AddItem("c2 = " & CStr(c2))
      
   c3 = A.Decrypt(c2)   ' A entschlsselt : Von B verschlsselt
   Call Form1.List3.AddItem("c3 = " & CStr(c3))
   
   Call B.SetKey(c3)    ' Von beiden entschlsselt: B hat den Klartext
   
End Sub
